# vim: set ft=spec: -*- rpm-spec -*-
# $Id: mingw32-gcc,v 1.11 2003/06/27 19:46:16 raorn Exp $

%define cross_arch mingw32
%define cross_fullarch i386-mingw32msvc

%define _archlibdir %_libdir/%cross_fullarch

Name: %cross_arch-gcc
Version: 3.3
Release: alt1

Summary: GNU Compiler Collection
License: GPL
Group: Development/Other
URL: http://gcc.gnu.org/

%define _gcclibdir %_libdir/gcc-lib/%cross_fullarch/%version

%def_with objc
%def_with fortran
# Can't build ada without working gnats :-(
%def_without ada

Source: ftp://ftp.gnu.org/gnu/gcc/gcc-%version/gcc-%version.tar.bz2

Requires: %cross_arch-runtime

# Automatically added by buildreq on Sat May 10 2003 and checked by raorn
BuildRequires: flex mingw32-binutils mingw32-runtime

%description
This package contains the GNU Compiler Collection version %version.
You'll need this package in order to crosscompile C code.
It is also required for all other GCC crosscompilers, namely C++,
Fortran 77, Objective C and Java.

This package contains crosscompilation tools for %cross_fullarch
target.

%package c++
Summary: C++ support for %name
Group: Development/Other
Requires: %name = %version-%release

%description c++
This package provides support for crosscompiling C++
programs with the GNU Compiler Collection.
It includes support for most of the current C++ specification,
including templates and exception handling.

%if_with fortran
%package g77
Summary: Fortran 77 support for %name
Group: Development/Other
Requires: %name = %version-%release

%description g77
This package provides support for crosscompiling Fortran 77
programs with the GNU Compiler Collection.
%endif

%if_with objc
%package objc
Summary: Objective-C support for %name
Group: Development/Other
Requires: %name = %version-%release

%description objc
This package provides support for crosscompiling Objective-C
programs with the GNU Compiler Collection.
Mainly used on systems running NeXTSTEP(tm), Objective-C is
an object-oriented derivative of the C language.
%endif

%if_with ada
%package -n %cross_arch-gnats
Summary: Ada support for %name
Group: Development/Other
Requires: %name = %version-%release

%description -n %cross_arch-gnats
This package provides support for crosscompiling Ada
programs with the GNU Compiler Collection.
%endif

%prep
%setup -q -n gcc-%version
# Dirty hackaround for libf2c
%__subst 's,\(gcc_version_trigger=\${toplevel_srcdir}/gcc/version\.c\),gcc_version_trigger=../../../gcc/version.c,' libf2c/configure
%__subst 's,^\([[:blank:]]*-DTOOLDIR_BASE_PREFIX=\)[^[:blank:]]*\(.*\)$,\1\\"%_libdir/\\"\2,' gcc/Makefile.in
%__subst 's,^\([[:blank:]]*gcc_tooldir="\)[^"]*\("\)$,\1%_libdir/\\$(target_alias)\2,' gcc/configure

%build
%define buildtarget build-%cross_fullarch
%__rm -rf %buildtarget
%__mkdir_p %buildtarget
pushd %buildtarget
%undefine __libtoolize
CFLAGS="${CFLAGS:-%optflags}" ; export CFLAGS ;
CXXFLAGS="${CXXFLAGS:-%optflags}" ; export CXXFLAGS ;
FFLAGS="${FFLAGS:-%optflags}" ; export FFLAGS ;
../configure \
	--build=%_target_platform \
	--host=%_target_platform \
	--target=%cross_fullarch \
	--prefix=%_prefix \
	--bindir=%_bindir \
	--sbindir=%_sbindir \
	--mandir=%_mandir \
	--infodir=%_infodir \
	--includedir=%_archlibdir/include \
	--libdir=%_libdir \
	--exec-prefix=%_libdir \
	--disable-nls \
	--disable-multilib \
	--with-gxx-include-dir=%_archlibdir/include/c++/%version \
	--includedir=%_archlibdir/include \
	--enable-languages="c,c++%{?_with_ada:,ada}%{?_with_fortran:,f77}%{?_with_objc:,objc}"

%make_build
popd #%buildtarget

%install
%__mkdir_p %buildroot%_archlibdir
pushd %buildtarget
%make_install \
	DESTDIR=%buildroot \
	install
popd #%buildtarget

# Collect some garbage
%__rm -rf %buildroot%_datadir

%files
%_bindir/%cross_fullarch-cpp
%_bindir/%cross_fullarch-gcc
%_bindir/%cross_fullarch-gcov
%_gcclibdir/cc1
#_gcclibdir/cpp0
%_gcclibdir/libgcc.*a
%_gcclibdir/specs
#_gcclibdir/tradcpp0
%dir %_gcclibdir/include
%_gcclibdir/include/float.h
%_gcclibdir/include/g2c.h
%_gcclibdir/include/iso646.h
%_gcclibdir/include/limits.h
%_gcclibdir/include/*mmintrin.h
%_gcclibdir/include/stdarg.h
%_gcclibdir/include/stdbool.h
%_gcclibdir/include/stddef.h
%_gcclibdir/include/syslimits.h
%_gcclibdir/include/varargs.h
%_gcclibdir/include/README

%files c++
%_bindir/%cross_fullarch-c++
#_bindir/%cross_fullarch-c++filt
%_bindir/%cross_fullarch-g++
%_gcclibdir/cc1plus
%_archlibdir/lib/libstdc++.*a
%_archlibdir/lib/libsupc++.*a
%_archlibdir/include/c++

%if_with fortran
%files g77
%_bindir/%cross_fullarch-g77
%_gcclibdir/f771
%_archlibdir/lib/libfrtbegin.*a
%_archlibdir/lib/libg2c.*a
%endif

%if_with objc
%files objc
%_gcclibdir/cc1obj
%_archlibdir/lib/libobjc.*a
%_gcclibdir/include/objc
%endif

%if_with ada
%files -n %cross_arch-gnats
# Filelist unknown...
%endif

%changelog
* Fri Jun 27 2003 Sir Raorn <raorn@altlinux.ru> 3.3-alt1
- [3.3]

* Sun May 11 2003 Sir Raorn <raorn@altlinux.ru> 3.2.3-alt7
- Subst gcc_tooldir... Hope this will be enough...

* Sun May 11 2003 Sir Raorn <raorn@altlinux.ru> 3.2.3-alt6
- Argh! tooldir_base_prefix was too deep...

* Sun May 11 2003 Sir Raorn <raorn@altlinux.ru> 3.2.3-alt5
- Hardcode tooldir_base_prefix

* Sun May 11 2003 Sir Raorn <raorn@altlinux.ru> 3.2.3-alt4
- Reconfigure with different layout...

* Sun May 11 2003 Sir Raorn <raorn@altlinux.ru> 3.2.3-alt3
- Fix as and ld names

* Sun May 11 2003 Sir Raorn <raorn@altlinux.ru> 3.2.3-alt2
- Fix requires

* Sat May 10 2003 Sir Raorn <raorn@altlinux.ru> 3.2.3-alt1
- Built for Sisyphus
 (Based on avr-* packages by week, crossutils-mingw32 by vsl and gcc by ldv)


